#ifndef __LSM_TREE_H__
#define __LSM_TREE_H__

#include <libxml/tree.h>
#include "LsmTypes.h"


#ifdef __cplusplus
extern          "C" {
#endif				/* // __cplusplus */

	LsmTree       *
	                LsmTree_new(int in_withContent);

	LsmTree       *
	                LsmTree_newFromLsmXmlFile(char *in_lsmXmlFile);

	LsmTree       *
	                LsmTree_newFromLsmXmlStream(char *in_lsmXmlStream);

	LsmTree       *
	                LsmTree_newFromLsmXmlDocPtr(xmlDocPtr in_lsmXmlDocPtr);

	LsmTree       *
	                LsmTree_newFromLsmXmlNodePtr(xmlNodePtr in_lsmXmlNodePtr);

	LsmTree       *
	                LsmTree_newFromDirectory(char *in_directory,
					                int in_withContent);


	int
	                LsmTree_toLsmXmlFile(LsmTree * self,
				                       char *in_lsmXmlFile);

	int
	                LsmTree_toLsmXmlStream(LsmTree * self,
				                   char **out_lsmXmlStream);

	int
	                LsmTree_toLsmXmlDocPtr(LsmTree * self,
			                      xmlDocPtr * out_lsmXmlDocPtr);

	int
	                LsmTree_toLsmXmlNodePtr(LsmTree * self,
			                    xmlNodePtr * out_lsmXmlNodePtr);

	int
	                LsmTree_toDirectory(LsmTree * self,
					                char *in_directory);

	int
	                LsmTree_destroy(LsmTree * self);

#ifdef __cplusplus
}
#endif				/* // __cplusplus */

#endif
