#ifndef __LSM_TREE_INTERNAL_H__
#define __LSM_TREE_INTERNAL_H__

#include <libxml/tree.h>
#include <sys/types.h>		/* for opendir , stat, getpwent, endpwent */
#include "LsmTypes.h"

#define LSM_COPYRIGHT "Strasser Michel, 2001 - 2003, this product is placed under\
 GPL, please see COPYING for further informations"

#define LSM_GENERATED "Generated by LsmLib"
#define LSM_MAXPATHSIZE 1024
#define LSM_MAXUSERNAMESIZE 256
#define LSM_MAXGROUPNAMESIZE 256
#define LSM_MAXSIZEOFSIZE 256
#define LSM_MAXTIMESIZE 30
#define LSM_MAXAUTHSIZE 10



#ifdef __cplusplus
extern          "C" {
#endif				/* // __cplusplus */


int
LsmTree_Internal_addPath(const char *tree,
		      const char *flower,
		      char fullName[LSM_MAXPATHSIZE]);

int
LsmTree_Internal_mode_t2string(mode_t umt,
			    char name[LSM_MAXAUTHSIZE]);

 int
LsmTree_Internal_time_t2string(time_t td,
			    char name[LSM_MAXTIMESIZE]);

int
LsmTree_Internal_int2string(int size,
			 char name[LSM_MAXSIZEOFSIZE]);

int
LsmTree_Internal_off_t2string(off_t size,
			   char name[LSM_MAXSIZEOFSIZE]);

int
LsmTree_Internal_uid2string(uid_t uid,
			 char name[LSM_MAXUSERNAMESIZE]);

int
LsmTree_Internal_gid2string(gid_t gid,
			 char name[LSM_MAXGROUPNAMESIZE]);

int
LsmTree_Internal_scanDir(const char *dir,
		      xmlNodePtr dirNode,
			  int in_withContent);

xmlDocPtr
LsmTree_Internal_constructXmlDoc(int in_withContent, 
		xmlNodePtr* out_filesRoot);

xmlDocPtr
LsmTree_Internal_getXmlDocPtrFromDirectory(const char *dir,
			  int in_withContent);

 void
LsmTree_Internal_hasContentXml2Struct(LsmTree * self);

int
LsmTree_Internal_isDocValid(LsmTree * self);


	
	void
LsmTree_Internal_toDirectoryRecursive(LsmTree * self,
			xmlNodePtr current,
		     char *in_directory);

	int
		LsmTree_Internal_saveFileAtFromXmlNodePtr(LsmTree* self,
				xmlNodePtr fileNode,
				char *at);

	xmlNodePtr
LsmTree_Internal_getFilesNode(LsmTree * self);

#ifdef __cplusplus
}
#endif				/* // __cplusplus */

#endif
