#include <glib.h>
#include "LsmTypes.h"
#include "LsmTree_VFS.h"
#include "LsmTree_Sync.h"

#define IMPL_LSMTREE_SYNC_AT(in_file, in_prefix) \
	((in_prefix)?(g_strconcat(in_prefix, in_file, NULL)):(g_strdup(in_file)))

int
LsmTree_Sync_file2Lsm		(LsmTree * self,
				 char *in_file,
				 char *in_prefix)
{
	int retval=LSM__ERROR__NO_ERROR;
	char* at=IMPL_LSMTREE_SYNC_AT(in_file, in_prefix);

	retval=LsmTree_VFS_addFileAt(self, at, in_file, NULL, NULL, NULL);

	return retval;
}

int
LsmTree_Sync_directory2Lsm	(LsmTree * self,
				 char *in_directory,
				 char *in_prefix)
{
	int retval=LSM__ERROR__NO_ERROR;
	char* at=IMPL_LSMTREE_SYNC_AT(in_directory, in_prefix);

	retval=LsmTree_VFS_addDirectoryAt(self, at, in_directory);

	return retval;
}

int
LsmTree_Sync_lsm2File		(LsmTree * self,
				 char *in_file,
				 char *in_prefix)
{
	int retval=LSM__ERROR__NO_ERROR;
	char* at=IMPL_LSMTREE_SYNC_AT(in_file, in_prefix);
	
	retval=LsmTree_VFS_saveFileAt(self, in_file, at);

	return retval;
}

int
LsmTree_Sync_lsm2Directory	(LsmTree * self,
				 char *in_directory,
				 char *in_prefix)
{
	int retval=LSM__ERROR__NO_ERROR;
	char* at=IMPL_LSMTREE_SYNC_AT(in_directory, in_prefix);

	retval=LsmTree_VFS_saveDirectoryAt(self, in_directory, at);
	
	return retval;
}



