#ifndef __LSM_TREE_VFS_H__
#define __LSM_TREE_VFS_H__

#include "LsmTypes.h"

#ifdef __cplusplus
extern          "C" {
#endif				/* // __cplusplus */

	int
	                LsmTree_VFS_saveFileAt(LsmTree * self,
					                      char *in_file,
						                char *in_at);

	int
	                LsmTree_VFS_saveDirectoryAt(LsmTree * self,
					                 char *in_directory,
					                       char *in_at);

	int
	                LsmTree_VFS_getFileAtAsStream(LsmTree * self,
						                char *in_at,
					                  char **out_stream,
					                   int *out_length);



	int
	                LsmTree_VFS_addFileAt(LsmTree * self,
					                       char *in_file,
					                       char *in_at,
					                       char *in_auth,
					                     char *in_owner,
					                    char *in_group);

	int
	                LsmTree_VFS_addDirectoryAt(LsmTree * self,
					                 char *in_directory,
						                char *in_at);

	int
	                LsmTree_VFS_addStreamAsFileAt(LsmTree * self,
					                    char *in_stream,
					                int in_streamLength,
						                char *in_at,
					                      char *in_auth,
					                     char *in_owner,
					                    char *in_group);

// begin TODO
	int
	                LsmTree_VFS_insertAnotherLsmTreeAt(LsmTree * self,
				                  LsmTree * anotherLsmTree,
					                       char *in_at);

// end TODO
	
	int
	                LsmTree_VFS_setDefaultAuth(LsmTree * self,
				                      char *in_defaultAuth);

	int
	                LsmTree_VFS_getDefaultAuth(LsmTree * self,
				                    char **out_defaultAuth);

	int
	                LsmTree_VFS_setDefaultOwner(LsmTree * self,
				                     char *in_defaultOwner);

	int
	                LsmTree_VFS_getDefaultOwner(LsmTree * self,
				                   char **out_defaultOwner);

	int
	                LsmTree_VFS_setDefaultGroup(LsmTree * self,
				                     char *in_defaultGroup);

	int
	                LsmTree_VFS_getDefaultGroup(LsmTree * self,
				                   char **out_defaultGroup);


#ifdef __cplusplus
}
#endif				/* // __cplusplus */

#endif
