#ifndef __LSM_MAIN_H__
#define __LSM_MAIN_H__

#define VERSION "2.0"
#define USAGE "usage: lsm2 [-h] [-i inFilter] [-o outFilter] [input] [output] \n \
\n \
\t-h \t: print this help message\n \
\t-v \t: print current version\n \
\t-i inFilter \t: where inFilter is \n \
\t\t\t* dir, import from a directory without the content of files (default)\n \
\t\t\t* xmlFile, import from an xmlFile\n \
\t\t\t* dirFull, import from a directory with the content of files\n \
\t-o outFilter \t: where outFilter is \n \
\t\t\t* dir, export to a directory \n \
\t\t\t* xmlFile, export to a xml file (default)\n \
\t\t\t* string, export to ASCII text \n \
\t\t\t* html, export to HTML \n \
\tinput \t: the input file or dir (usually default to current dir)\n \
\toutput \t: the export file or dir (default to current dir or xml on stdout)\n \
"

typedef enum { 
	LSM__INPUT_FILTER__XML_FILE,
	LSM__INPUT_FILTER__DIR,
	LSM__INPUT_FILTER__DIR_FULL
} LsmInputFilter;

typedef enum { 
	LSM__OUTPUT_FILTER__DIR,
	LSM__OUTPUT_FILTER__XML_FILE,
	LSM__OUTPUT_FILTER__STRING,
	LSM__OUTPUT_FILTER__HTML
} LsmOutputFilter;

typedef struct _LsmOpts LsmOpts;

struct _LsmOpts {
	LsmInputFilter	inputFilter;
	LsmOutputFilter	outputFilter;
	char* 		input;
	char*		output;
};



#endif
